indexing

	description:

		"Test features of Erl-G on class HASH_TABLE [ANY, STRING]"

	library: "Erl-G Library"
	copyright: "Copyright (c) 2005, Ilinca Ciupa and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2005/09/02 11:38:47 $"
	revision: "$Revision: 1.1 $"

deferred class ERL_G_TEST_LIVE_TYPES

inherit

	TS_TEST_CASE
	
	ERL_SHARED_UNIVERSE
		export {NONE} all end
		

feature -- Test reflection on generated system

	test_suppliers_live is
			-- Test that ancestors of live types are also live.
		local
			person_type, integer_type, boolean_type, string_type: ERL_TYPE
		do
				-- If PERSON is live, then STRING, INTEGER, and BOOLEAN should also be live.
			assert_not_equal ("PERSON type live", Void, universe.type_by_name ("PERSON"))	
			assert_not_equal ("INTEGER type live", Void, universe.type_by_name ("INTEGER"))
			assert_not_equal ("STRING type live", Void, universe.type_by_name ("STRING"))
			assert_not_equal ("BOOLEAN type live", Void, universe.type_by_name ("BOOLEAN"))
			
				-- If HASH_TABLE [ANY, STRING] is live, then ARRAY [ANY], ARRAYED_LIST [ANY],
				-- BOOLEAN, HASH_TABLE_CURSOR, INTEGER, MISMATCH_CORRECTOR, MISMATCH_INFORMATION,
				-- PRIMES, REAL, and SPECIAL [ANY] should also be live.
			assert_not_equal ("HASH_TABLE [ANY, STRING] type live", Void, universe.type_by_name ("HASH_TABLE [ANY, STRING]"))	
			assert_not_equal ("ARRAY [ANY] type live", Void, universe.type_by_name ("ARRAY [ANY]"))
			assert_not_equal ("ARRAYED_LIST [ANY] type live", Void, universe.type_by_name ("ARRAYED_LIST [ANY]"))
			assert_not_equal ("HASH_TABLE_CURSOR type live", Void, universe.type_by_name ("HASH_TABLE_CURSOR"))
			assert_not_equal ("MISMATCH_CORRECTOR type live", Void, universe.type_by_name ("MISMATCH_CORRECTOR"))
			assert_not_equal ("MISMATCH_INFORMATION type live", Void, universe.type_by_name ("MISMATCH_INFORMATION"))
			assert_not_equal ("PRIMES type live", Void, universe.type_by_name ("PRIMES"))
			assert_not_equal ("REAL type live", Void, universe.type_by_name ("REAL"))
			assert_not_equal ("SPECIAL [ANY] type live", Void, universe.type_by_name ("SPECIAL [ANY]"))
			
				-- If ARRAYED_LIST [INTEGER] is live, then ANY, ARRAY [ANY], ARRAYED_LIST_CURSOR,
				-- BOOLEAN, INTEGER, and SPECIAL [ANY] should also be live.
			assert_not_equal ("ARRAYED_LIST [INTEGER] type live", Void, universe.type_by_name ("ARRAYED_LIST [INTEGER]"))	
			assert_not_equal ("ARRAY [ANY] type live", Void, universe.type_by_name ("ARRAY [ANY]"))
			assert_not_equal ("ARRAYED_LIST_CURSOR type live", Void, universe.type_by_name ("ARRAYED_LIST_CURSOR"))
			assert_not_equal ("ANY type live", Void, universe.type_by_name ("ANY"))
			assert_not_equal ("SPECIAL [ANY] type live", Void, universe.type_by_name ("SPECIAL [ANY]"))
		end

end
